<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <style>
            main{
                padding: 0;
                margin: 0;
                font-family: 'Lato';
                max-width: 500px;
                margin: 0 auto;  
            }

            .flex{
                display: flex;
            }

            .wrap{
                flex-wrap: wrap;
            }

            .center{
                justify-content: center;
            }

            .w20{
                width: 20%;    
            }

            .w90{
                width: 90%;
            }

            .w100{
                width: 100%;
            }

            .cel{
                height: 82px;
                z-index: 1;
                width: 90%;
                font-weight: bold;
                position: relative;
                margin: 5px auto;
                background-color: #1aa1f0;
                border-radius: 10px;    
                text-align: center;    
                justify-content: center;
                font-size: 2.25em;
                align-items: center;
            }

            .comprobar, .info{
                border: 1px solid #1aa1f0;
                border-radius: 5px;
                font-size: 1.2em;
                margin-bottom: 15px;
                margin-top: 15px;
            }

            .comprobar *, .info *{
                margin: 10px;
            }

            .info{
                border-color: crimson;
                background-color: crimson;
                color: white;
            }

            label{
                color: #1aa1f0;
                font-weight: bold;
            }

            input{
                box-sizing: border-box;
                width: 40%;    
                border: none;
                margin-bottom: 15px;
                font-size: 1.2em;
                padding: 10px;
                border-bottom: 2px solid #1aa1f0;
                outline: none;
                border-radius: 5px 5px 0 0;
            }

            input:focus, input:hover{    
                background-color: #BABABA;
            }

            button{
                width: 55%;
                padding: 15px;
                background-color: #1aa1f0;
                color: white;
                border: none;
                border-radius: 5px;
                font-size: 1.17em;
                margin-bottom: 10px;
            }

            button:hover, button:focus{    
                background-color: #1aa1f075;    
                cursor: pointer;
            }

            .celResult{
                height: 82px;
                z-index: 1;
                width: 90%;
                font-weight: bold;
                position: relative;
                margin: 5px auto;
                background-color: #BABABA;
                border-radius: 10px;    
                text-align: center;    
                justify-content: center;
                font-size: 2.25em;
                align-items: center;
            }

    </style>
    <title>Número secreto</title>
</head>

<body>
    <main>
        <h1>Adivina el número secreto</h1>
        <section id="codigo" class="flex wrap center">
            <div class="codigoSecreto w100 flex wrap">
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
            </div>
        </section>
        <section class="w100 flex wrap center comprobar">
            <label class="w90" for="numero">Escribe aquí un número</label><br>
            <input class="w90" type="text" id="numero" name="numero" value="12345"><br>
            <button class="w90" id="check" onclick="Comprobar()">Comprobar</button>
            
        </section>
        <section class="w100 info">
        <p class="w90" id="info">Primer intento, suerte!</p>
        </section>
        <section id="Result" class="flex wrap center">
            <!-- Esto debereís generarlo más adelante por código -->
        </section>
    </main>
    <script>

        //Definir el número de intentos y la variable para contarlos
        const maximoIntentos = 8;
        let intentos = 0;
        function generarCodigoAleatorio(){
            return Math.floor(Math.random() * 90000) + 10000
        }

        //Definir un número que va a ser mayor que 10 000 y menor que 100 000, por lo tanto, de 5 cifras.
        let codigo = generarCodigoAleatorio().toString();
        console.log(codigo)

        //Definir los elementos del DOM
        const mensaje = document.getElementById("info");
        let input = document.getElementById('numero');
                
        let acabado = false;
        let incorrecto = false;

        function Comprobar(){
            //Recoger el número que introduce el usuario y pasarlo a string para comprobarlo luego
            let intento = input.value;
            if (intento.length < 5 || isNaN(intento)){
                incorrecto = true;
                mensaje.innerHTML = "ERROR. Debes introducir un número de 5 dígitos!"
            } else {

            
            intento = intento.toString();
            let aciertos = 0;
            if (acabado){
                return;
            }

            //Crear un fragmento y una fila
            let fragmento = document.createDocumentFragment();
            let fila = document.createElement("div");
            fila.className = "rowResult w100 flex wrap";

            //Dentro de la fila crear las 5 celdas
            for (let i = 0; i<5; i++){
                
                let w20 = document.createElement("div");
                w20.className = "w20";
                let celda = document.createElement("div");
                celda.className = "celResult flex";
            
                w20.appendChild(celda);
                fila.appendChild(w20);
            }

            fragmento.appendChild(fila);
            document.getElementById("Result").prepend(fragmento);

            //Mostrar el número ingresado por el jugador en la celda
            let columnaUsuario = document.getElementsByClassName("rowResult")[0];
            let celdaUsuario = columnaUsuario.getElementsByClassName("celResult");
            
            for (let i = 0; i < 5; i++){
                celdaUsuario[i].innerHTML = intento[i]
            }
            
            //Comprobar si el dígito del número introducido por el usuario corresponde al del código secreto.
            for (let i = 0; i < 5; i++) {

                // Pintar de gris oscuro todas las celdas. Posteriormente se volverán a pintar si el número está
                celdaUsuario[i].style.backgroundColor = "#696969";

                //Si la posición coincide exactamente ha acertado y el fondo es verde
                if (intento.charAt(i) == codigo.charAt(i)) {
                    aciertos++;
                    celdaUsuario[i].style.backgroundColor = "green";

                } else {

                    // Comprobar si el dígito está en el código secreto
                    for (let j = 0; j < 5; j++) {
                        
                        if ((intento.charAt(i) == codigo.charAt(j)) && (intento.charAt(j) != codigo.charAt(j))) {
                            // Pintar de amarillo si está pero en posición errónea
                            celdaUsuario[i].style.backgroundColor = "yellow";
                        }
                    }
                }
            }
            
            //Al acabar la partida, mostrar en las celdas de arriba del todo el número que era.
            intentos++;
            if(aciertos == 5 || intentos == maximoIntentos){
                acabado = true;
                let filaCodigo = document.getElementsByClassName("codigoSecreto")[0];
                let celCodigo = filaCodigo.getElementsByClassName("cel");

                for (let i = 0; i < 5; i++) {
                    celCodigo[i].innerHTML = codigo[i];
                }
            }

            //Modificar el mensaje y poner el progreso de la partida

            if (aciertos == 5) {
                mensaje.innerHTML = "Enhorabuena, has ganado. Y tan solo has necesitado " + intentos + " intentos";
            
            } else {
                var intentosRestantes = maximoIntentos-intentos
                mensaje.innerHTML = "Intentos restantes: " + intentosRestantes;
            }

            if(intentos >= maximoIntentos && aciertos < 5) {
                mensaje.innerHTML = "Te quedaste sin intentos. El número era " +codigo + ". Más suerte la próxima vez. Recarga la página para jugar de nuevo!";
            }

        }
    }

    </script>
</body>

</html>